# Cybus::Role

Creates a new *role* resource. See also [user and role management](/1-10-2/documentation/user-management.md).

The role defined here can be used in the list of roles for a [Cybus::User](/1-10-2/documentation/services/service-commissioning-files/resources/cybus-user.md) resource, which is the suggested way of specifying a set of permissions for a user.

## Properties

| Property                    | Type       | Required     |
| --------------------------- | ---------- | ------------ |
| [permissions](#permissions) | `object[]` | **Required** |

### permissions

The permissions associated to this role

* is **required**
* type: `object[]`; all items must be of the type: `object` with following properties:

| Property                | Type   | Required     |
| ----------------------- | ------ | ------------ |
| [context](#context)     | string | **Required** |
| [operation](#operation) | string | **Required** |
| [resource](#resource)   | string | **Required** |

#### context

The context in which the role permissions for the resource should be interpreted.

* is **required**
* type: `enum`; the value of this property **must** be equal to one of the below:
  * `mqtt` when describing permissions for MQTT topics
  * `http` when describing permissions for REST API paths

#### operation

The allowed access operation to the resource.

* is **required**
* type: `enum`; the value of this property **must** be equal to one of the below:
  * `read`
  * `write`
  * `readWrite`

#### resource

Resource path. Can be REST-ful API path or MQTT topic.

* is **required**
* type: `string`

## Example

{% code lineNumbers="true" %}

```yaml
myRole:
    type: Cybus::Role
    properties:
        permissions:
            - resource: edge.cybus/#
              operation: readWrite
              context: mqtt
```

{% endcode %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cybus.io/1-10-2/documentation/services/service-commissioning-files/resources/cybus-role.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
